"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var environment_transform_exports = {};
__export(environment_transform_exports, {
  transform: () => transform
});
module.exports = __toCommonJS(environment_transform_exports);
var import_lodash = require("lodash");
var import_assert = require("@code-like-a-carpenter/assert");
var import_foundation_plugin_cloudformation = require("@code-like-a-carpenter/foundation-plugin-cloudformation");
const transform = (ir, template, nestedTemplates) => {
  const globalVars = template.Globals?.Function?.Environment?.Variables;
  if (!globalVars) {
    return;
  }
  const nestedVars = {};
  const nestedParams = {};
  const params = {};
  for (const [key, value] of Object.entries(globalVars)) {
    const constCase = key;
    const pascalCase = (0, import_lodash.upperFirst)((0, import_lodash.camelCase)(key));
    nestedVars[constCase] = { Ref: pascalCase };
    nestedParams[pascalCase] = {
      Type: "String"
    };
    params[pascalCase] = value;
  }
  for (const tpl of nestedTemplates.values()) {
    tpl.Globals = {
      ...tpl.Globals,
      Function: {
        ...tpl.Globals?.Function,
        Environment: {
          ...tpl.Globals?.Function?.Environment ?? {},
          Variables: {
            // @ts-expect-error - typedef does not include Variables
            ...tpl.Globals?.Function?.Environment?.Variables,
            ...nestedVars
          }
        }
      }
    };
    tpl.Parameters = {
      ...tpl.Parameters,
      ...nestedParams
    };
  }
  Object.entries(template.Resources).filter(([, resource]) => resource.Type === "AWS::Serverless::Application").filter(
    ([resourceName]) => (0, import_foundation_plugin_cloudformation.isDispatcherStack)(resourceName) || (0, import_foundation_plugin_cloudformation.isHandlerStack)(resourceName)
  ).forEach(([, resource]) => {
    (0, import_assert.assert)(
      resource.Type === "AWS::Serverless::Application",
      "Expected resource to be a Serverless Application"
    );
    (0, import_assert.assert)(resource.Properties, "Expected resource to have properties");
    const existing = resource.Properties.Parameters ?? {};
    resource.Properties.Parameters = {
      ...existing,
      ...params
    };
  });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  transform
});
